using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
	class ColliderDebug : MonoBehaviour
    {
        void Update()
        {
            foreach (Collider2D coller in gameObject.GetComponents<Collider2D>())
            {
                ModAPI.Draw.Collider(coller); //Instance.AddComponent<ColliderDebug>(); (add this to instances)
            }
        }
    }
    public class Mod
    {
		public static string tarantactical = "<color=orange>[G&R: Taran Tactical®] <color=white>";
        public static void Main()
        {				
			 CategoryBuilder.Create("\n<color=orange>G&R: Taran Tactical®", "'The Ultimate Weapons & Accessories for Competition. Military & Law Enforcement. The Gundies most Innovative Brand of the year'", ModAPI.LoadSprite("TaranIcon.png"));
												
				ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = tarantactical + tarantactical + "M4E1 TTI Ultralight Rifle",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "If you’re looking for a plinker or a home defense gun, the Aero M4E1 is a fantastic option. It gives surprisingly good accuracy, even with strings of rapid fire, subpar ammo, and minimal maintenance.",
                    CategoryOverride = ModAPI.FindCategory("\n<color=orange>G&R: Taran Tactical®"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/M41Icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects(); 
                        var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Back1.png", 16f);
                        childSprite.sortingLayerName = "Background";                     
                        childSprite.sortingOrder = +1;
						
						var Slide = Instance.transform.Find("Slide");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Bolt1.png", 16f);
                        Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
												
						var DotLight = new GameObject("eye");
						DotLight.transform.SetParent(Instance.transform);
						DotLight.transform.localPosition = new Vector3(0f, 0f);
						DotLight.transform.localScale = new Vector3(1f, 1f);
						var DotLightSprite = DotLight.AddComponent<SpriteRenderer>();
						DotLightSprite.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Light.png" ,16f);
						DotLightSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						DotLight.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						DotLightSprite.color = new Color(1f, 1f, 1f, 0.05f);
						 
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle.png", 16f); 
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						 
                        
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
                        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                        
                        firearm.Cartridge = customCartridge;
                        customCartridge.name = "cartridge";                                        
                        customCartridge.Recoil *= 3f;        
                        customCartridge.Damage *= 1f;						
                        firearm.casingPosition = new Vector3(-0.05f, 0.1f);   
                       
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();
						
						var childObject2 = new GameObject("bolt2");
                        childObject2.transform.SetParent(Slide.transform);
                        childObject2.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject2.transform.rotation = Instance.transform.rotation;
                        childObject2.transform.localScale = new Vector3(1f, 1f);
                        var childSprite2 = childObject2.AddComponent<SpriteRenderer>();
                        childSprite2.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Bolt 2.png", 16f);
                        childSprite2.sortingLayerName = "Default";                     
                        childSprite2.sortingOrder = +1;

                        
                        ;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.085f;
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.67f, 0.115f);
                        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;
						firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/AR15.wav"),

                        };
                    }
                }
            );
			
												
				ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = tarantactical + "M4E1 TTI Ultralight Rifle (Holosun HS512C)",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "If you’re looking for a plinker or a home defense gun, the Aero M4E1 is a fantastic option. It gives surprisingly good accuracy, even with strings of rapid fire, subpar ammo, and minimal maintenance.",
                    CategoryOverride = ModAPI.FindCategory("\n<color=orange>G&R: Taran Tactical®"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/M41Icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects(); 
                        var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Back2.png", 16f);
                        childSprite.sortingLayerName = "Background";                     
                        childSprite.sortingOrder = +1;
						
						var Slide = Instance.transform.Find("Slide");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Bolt1.png", 16f);
                        Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
												
						var DotLight = new GameObject("eye");
						DotLight.transform.SetParent(Instance.transform);
						DotLight.transform.localPosition = new Vector3(0f, 0f);
						DotLight.transform.localScale = new Vector3(1f, 1f);
						var DotLightSprite = DotLight.AddComponent<SpriteRenderer>();
						DotLightSprite.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Light.png" ,16f);
						DotLightSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						DotLight.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						DotLightSprite.color = new Color(1f, 1f, 1f, 0.05f);
						 
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle 2.png", 16f); 
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						 
                        
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
                        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                        
                        firearm.Cartridge = customCartridge;
                        customCartridge.name = "cartridge";                                        
                        customCartridge.Recoil *= 3f;        
                        customCartridge.Damage *= 1f;						
                        firearm.casingPosition = new Vector3(-0.05f, 0.1f);   
                       
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();
						
						var childObject2 = new GameObject("bolt2");
                        childObject2.transform.SetParent(Slide.transform);
                        childObject2.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject2.transform.rotation = Instance.transform.rotation;
                        childObject2.transform.localScale = new Vector3(1f, 1f);
                        var childSprite2 = childObject2.AddComponent<SpriteRenderer>();
                        childSprite2.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Bolt 2.png", 16f);
                        childSprite2.sortingLayerName = "Default";                     
                        childSprite2.sortingOrder = +1;

                        
                        ;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.085f;
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.67f, 0.115f);
                        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;
						firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/AR15.wav"),

                        };
                    }
                }
            );
			
												
				ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = tarantactical + "M4E1 TTI Ultralight Rifle (Holosun HS510C)",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "If you’re looking for a plinker or a home defense gun, the Aero M4E1 is a fantastic option. It gives surprisingly good accuracy, even with strings of rapid fire, subpar ammo, and minimal maintenance.",
                    CategoryOverride = ModAPI.FindCategory("\n<color=orange>G&R: Taran Tactical®"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/M41Icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects(); 
                        var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Back4.png", 16f);
                        childSprite.sortingLayerName = "Background";                     
                        childSprite.sortingOrder = +1;
						
						var Slide = Instance.transform.Find("Slide");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Bolt1.png", 16f);
                        Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
												
						var DotLight = new GameObject("eye");
						DotLight.transform.SetParent(Instance.transform);
						DotLight.transform.localPosition = new Vector3(0f, 0f);
						DotLight.transform.localScale = new Vector3(1f, 1f);
						var DotLightSprite = DotLight.AddComponent<SpriteRenderer>();
						DotLightSprite.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Light.png" ,16f);
						DotLightSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						DotLight.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						DotLightSprite.color = new Color(1f, 1f, 1f, 0.05f);
						 
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle4.png", 16f); 
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						 
                        
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
                        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                        
                        firearm.Cartridge = customCartridge;
                        customCartridge.name = "cartridge";                                        
                        customCartridge.Recoil *= 3f;        
                        customCartridge.Damage *= 1f;						
                        firearm.casingPosition = new Vector3(-0.05f, 0.1f);   
                       
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();
						
						var childObject2 = new GameObject("bolt2");
                        childObject2.transform.SetParent(Slide.transform);
                        childObject2.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject2.transform.rotation = Instance.transform.rotation;
                        childObject2.transform.localScale = new Vector3(1f, 1f);
                        var childSprite2 = childObject2.AddComponent<SpriteRenderer>();
                        childSprite2.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Bolt 2.png", 16f);
                        childSprite2.sortingLayerName = "Default";                     
                        childSprite2.sortingOrder = +1;

                        
                        ;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.085f;
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.67f, 0.115f);
                        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;
						firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/AR15.wav"),

                        };
                    }
                }
            );
			
															
				ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = tarantactical + "M4E1 TTI Ultralight Rifle (Holosun HS510C + HM3X Combo)",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "If you’re looking for a plinker or a home defense gun, the Aero M4E1 is a fantastic option. It gives surprisingly good accuracy, even with strings of rapid fire, subpar ammo, and minimal maintenance.",
                    CategoryOverride = ModAPI.FindCategory("\n<color=orange>G&R: Taran Tactical®"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/M44Icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects(); 
                        var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Back3.png", 16f);
                        childSprite.sortingLayerName = "Background";                     
                        childSprite.sortingOrder = +1;
						
						var Slide = Instance.transform.Find("Slide");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Bolt1.png", 16f);
                        Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
												
						var DotLight = new GameObject("eye");
						DotLight.transform.SetParent(Instance.transform);
						DotLight.transform.localPosition = new Vector3(0f, 0f);
						DotLight.transform.localScale = new Vector3(1f, 1f);
						var DotLightSprite = DotLight.AddComponent<SpriteRenderer>();
						DotLightSprite.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Light.png" ,16f);
						DotLightSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						DotLight.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						DotLightSprite.color = new Color(1f, 1f, 1f, 0.05f);
						 
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle 3.png", 16f); 
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						 
                        
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
                        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                        
                        firearm.Cartridge = customCartridge;
                        customCartridge.name = "cartridge";                                        
                        customCartridge.Recoil *= 3f;        
                        customCartridge.Damage *= 1f;						
                        firearm.casingPosition = new Vector3(-0.05f, 0.1f);   
                       
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();
						
						var childObject2 = new GameObject("bolt2");
                        childObject2.transform.SetParent(Slide.transform);
                        childObject2.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject2.transform.rotation = Instance.transform.rotation;
                        childObject2.transform.localScale = new Vector3(1f, 1f);
                        var childSprite2 = childObject2.AddComponent<SpriteRenderer>();
                        childSprite2.sprite = ModAPI.LoadSprite("Taran Tactical/M4E1 TTI Ultralight Rifle Bolt 2.png", 16f);
                        childSprite2.sortingLayerName = "Default";                     
                        childSprite2.sortingOrder = +1;

                        
                        ;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.085f;
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.67f, 0.115f);
                        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;
						firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/AR15.wav"),

                        };
                    }
                }
            );
									
				ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = tarantactical + "TTI JW3 MPX",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "Using the base of the MPX, Taran Tactical has created an improved version of the MPX which adapts to your needs. featured In John Wick Chapter 2",
                    CategoryOverride = ModAPI.FindCategory("\n<color=orange>G&R: Taran Tactical®"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/MPX1Icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects(); 
                        var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Taran Tactical/TTI JW3 MPX Back1.png", 15f);
                        childSprite.sortingLayerName = "Background";                     
                        childSprite.sortingOrder = +1;
						
						var Slide = Instance.transform.Find("Slide");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/TTI JW3 MPX Bolt1.png", 15f);
                        Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
												
						var DotLight = new GameObject("eye");
						DotLight.transform.SetParent(Instance.transform);
						DotLight.transform.localPosition = new Vector3(0f, 0f);
						DotLight.transform.localScale = new Vector3(1f, 1f);
						var DotLightSprite = DotLight.AddComponent<SpriteRenderer>();
						DotLightSprite.sprite = ModAPI.LoadSprite("Taran Tactical/TTI JW3 MPX Light.png" ,15f);
						DotLightSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						DotLight.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						DotLightSprite.color = new Color(1f, 1f, 1f, 0.05f);
						 
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/TTI JW3 MPX.png", 15f); 
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						 
                        
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        
                        firearm.Cartridge = customCartridge;
                        customCartridge.name = "cartridge";                                        
                        customCartridge.Recoil *= 3f;        
                        customCartridge.Damage *= 1f;						
                        firearm.casingPosition = new Vector3(-0.05f, 0.1f);   					
                       
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();
						
						var childObject2 = new GameObject("bolt2");
                        childObject2.transform.SetParent(Slide.transform);
                        childObject2.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject2.transform.rotation = Instance.transform.rotation;
                        childObject2.transform.localScale = new Vector3(1f, 1f);
                        var childSprite2 = childObject2.AddComponent<SpriteRenderer>();
                        childSprite2.sprite = ModAPI.LoadSprite("Taran Tactical/TTI JW3 MPX Bolt 2.png", 15f);
                        childSprite2.sortingLayerName = "Default";                     
                        childSprite2.sortingOrder = +1;

                        
                        ;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.085f;
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.67f, 0.115f);
                        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;
						firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/MPX.wav"),

                        };
                    }
                }
            );
			
												
				ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = tarantactical + "TTI Benelli M4",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "Taran Tactical Innovations Benelli M4 Shotgun. Custom Benelli M4 modified to Taran Butler's specifications and featured In John Wick Chapter 2.",
                    CategoryOverride = ModAPI.FindCategory("\n<color=orange>G&R: Taran Tactical®"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/M10141Icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects(); 
                        var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Taran Tactical/TTI Benelli M4 Back1.png", 13f);
                        childSprite.sortingLayerName = "Background";                     
                        childSprite.sortingOrder = +1;
						
						var Slide = Instance.transform.Find("Slide");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/TTI Benelli M4 Bolt1.png", 13f);
                        Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
												
						var DotLight = new GameObject("eye");
						DotLight.transform.SetParent(Instance.transform);
						DotLight.transform.localPosition = new Vector3(0f, 0f);
						DotLight.transform.localScale = new Vector3(1f, 1f);
						var DotLightSprite = DotLight.AddComponent<SpriteRenderer>();
						DotLightSprite.sprite = ModAPI.LoadSprite("Taran Tactical/TTI Benelli M4 Light.png" ,13f);
						DotLightSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						DotLight.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						DotLightSprite.color = new Color(1f, 1f, 1f, 0.05f);
						 
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/TTI Benelli M4.png", 13f); 
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						 
                        
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
                        Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                        
                        firearm.Cartridge = customCartridge;
                        customCartridge.name = "cartridge";                                        
                        customCartridge.Recoil *= 1f;          
						customCartridge.Damage *= 1f;
                        firearm.casingPosition = new Vector3(-0.05f, 0.095f);   
						firearm.casingDirection = new Vector3(0f, 0.2f);   					
                       
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();
						
						var childObject2 = new GameObject("bolt2");
                        childObject2.transform.SetParent(Slide.transform);
                        childObject2.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject2.transform.rotation = Instance.transform.rotation;
                        childObject2.transform.localScale = new Vector3(1f, 1f);
                        var childSprite2 = childObject2.AddComponent<SpriteRenderer>();
                        childSprite2.sprite = ModAPI.LoadSprite("Taran Tactical/TTI Benelli M4 Bolt 2.png", 13f);
                        childSprite2.sortingLayerName = "Default";                     
                        childSprite2.sortingOrder = +1;

                        
                        ;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 6;
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.765f, 0.095f);
                        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;
						firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/Shotgun.wav"),

                        };
                    }
                }
            );
			
															
				ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = tarantactical + "JW3 Benelli M2",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "Multi-gun and tactical shotgun competitions push firearms to their limits by demanding the highest levels of reliability and accuracy. Benelli’s popular Performance. JW3 Benelli M2 shotgun's sports a large loading port for greater efficiency when quad loading, an XS express rear sight for slug accuracy, and a port caddy for a spare shell. Benelli's M2 has a stellar reputation as the shotgun of choice for serious 3-gun competitors. Available in 12-gauge only. It was featured In John Wick Chapter 2",
                    CategoryOverride = ModAPI.FindCategory("\n<color=orange>G&R: Taran Tactical®"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/BenelliM21Icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects(); 
                        var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Taran Tactical/JW3 Benelli M2 Back1.png", 13f);
                        childSprite.sortingLayerName = "Background";                     
                        childSprite.sortingOrder = +1;
						
						var Slide = Instance.transform.Find("Slide");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/JW3 Benelli M2 Bolt1.png", 13f);
                        Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
												
						var DotLight = new GameObject("eye");
						DotLight.transform.SetParent(Instance.transform);
						DotLight.transform.localPosition = new Vector3(0f, 0f);
						DotLight.transform.localScale = new Vector3(1f, 1f);
						var DotLightSprite = DotLight.AddComponent<SpriteRenderer>();
						DotLightSprite.sprite = ModAPI.LoadSprite("Taran Tactical/JW3 Benelli M2 Light.png" ,13f);
						DotLightSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						DotLight.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						DotLightSprite.color = new Color(0f, 1f, 0f, 0.25f);
						 
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/JW3 Benelli M2.png", 13f); 
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						 
                        
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        
                        firearm.Cartridge = customCartridge;
                        customCartridge.name = "cartridge";                                        
                        customCartridge.Recoil *= 1f;          
						customCartridge.Damage *= 1f;
                        firearm.casingPosition = new Vector3(-0.05f, 0.095f);   
						firearm.casingDirection = new Vector3(0f, 0.2f);   				
                       
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();
						
						var childObject2 = new GameObject("bolt2");
                        childObject2.transform.SetParent(Slide.transform);
                        childObject2.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject2.transform.rotation = Instance.transform.rotation;
                        childObject2.transform.localScale = new Vector3(1f, 1f);
                        var childSprite2 = childObject2.AddComponent<SpriteRenderer>();
                        childSprite2.sprite = ModAPI.LoadSprite("Taran Tactical/JW3 Benelli M2 Bolt 2.png", 13f);
                        childSprite2.sortingLayerName = "Default";                     
                        childSprite2.sortingOrder = +1;

                        
                        ;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 6;
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.765f, 0.095f);
                        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;
						firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/Shotgun2.wav"),

                        };
                    }
                }
            );
			
				ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = tarantactical + "Combat Master Glock G34 TTI",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "Using the base of the Glock 34 Gen 3, an extremely reliable 9mm pistol has been created for use in self-defense, sport shooting and other tasks. It was featured In John Wick Chapter 2",
                    CategoryOverride = ModAPI.FindCategory("\n<color=orange>G&R: Taran Tactical®"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/Glock34Icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects(); 
                        var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Taran Tactical/Combat Master Glock G34 TTI Back1.png", 23f);
                        childSprite.sortingLayerName = "Background";                     
                        childSprite.sortingOrder = +1;
						
						var Slide = Instance.transform.Find("Slide");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/Combat Master Glock G34 TTI Bolt1.png", 23f);
                        Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						
						var DotLight = new GameObject("eye");
						DotLight.transform.SetParent(Slide.transform);
						DotLight.transform.localPosition = new Vector3(0f, 0f);
						DotLight.transform.localScale = new Vector3(1f, 1f);
						var DotLightSprite = DotLight.AddComponent<SpriteRenderer>();
						DotLightSprite.sprite = ModAPI.LoadSprite("Taran Tactical/Combat Master Glock G34 TTI Light.png" ,23f);
						DotLightSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						DotLight.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						DotLightSprite.color = new Color(0f, 1f, 0f, 0.25f);
						 
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/Combat Master Glock G34 TTI.png", 23f); 
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						 
                        
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        
                        firearm.Cartridge = customCartridge;
                        customCartridge.name = "cartridge";                                        
                        customCartridge.Recoil *= 4f;         
                        customCartridge.Damage *= 1f;						
                        firearm.casingPosition = new Vector3(0.03f, 0.1f);   						
                       
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();
						
						var childObject2 = new GameObject("bolt2");
                        childObject2.transform.SetParent(Slide.transform);
                        childObject2.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject2.transform.rotation = Instance.transform.rotation;
                        childObject2.transform.localScale = new Vector3(1f, 1f);
                        var childSprite2 = childObject2.AddComponent<SpriteRenderer>();
                        childSprite2.sprite = ModAPI.LoadSprite("Taran Tactical/Combat Master Glock G34 TTI Bolt 2.png", 23f);
                        childSprite2.sortingLayerName = "Background";                     
                        childSprite2.sortingOrder = -1;

                        
                        ;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.1f, 0.12f);
                        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;
						firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/Glock19.wav"),

                        };
                    }
                }
            );
			
						
				ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = tarantactical + "Combat Master JW3",
                    NameToOrderByOverride = "Z",
                    DescriptionOverride = "Using the base of the M1911 pistol and a modernized version like the M45, an incredible and reliable .45 ACP pistol created by Taran Tactical has been created and with the best parts for defense or shooting among other activities.",
                    CategoryOverride = ModAPI.FindCategory("\n<color=orange>G&R: Taran Tactical®"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/M19111Icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.KeepExtraObjects(); 
                        var childObject = new GameObject("ChildObject");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject.transform.rotation = Instance.transform.rotation;
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Taran Tactical/JW3 Combat Master Back1.png", 23f);
                        childSprite.sortingLayerName = "Background";                     
                        childSprite.sortingOrder = +1;
						
						var Slide = Instance.transform.Find("Slide");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/JW3 Combat Master Bolt1.png", 23f);
                        Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						
																		
						var DotLight = new GameObject("eye");
						DotLight.transform.SetParent(Slide.transform);
						DotLight.transform.localPosition = new Vector3(0f, 0f);
						DotLight.transform.localScale = new Vector3(1f, 1f);
						var DotLightSprite = DotLight.AddComponent<SpriteRenderer>();
						DotLightSprite.sprite = ModAPI.LoadSprite("Taran Tactical/JW3 Combat Master Light.png" ,23f);
						DotLightSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
						DotLight.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						DotLightSprite.color = new Color(0f, 1f, 0f, 0.25f);
						
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Taran Tactical/JW3 Combat Master.png", 23f); 
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						 
                        
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        
                        firearm.Cartridge = customCartridge;
                        customCartridge.name = "cartridge";                                        
                        customCartridge.Recoil *= 4f;   
                        customCartridge.Damage *= 1f;						
                        firearm.casingPosition = new Vector3(0.03f, 0.1f);   						
                       
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();
						
						var childObject2 = new GameObject("bolt2");
                        childObject2.transform.SetParent(Slide.transform);
                        childObject2.transform.localPosition = new Vector3(0f, 0f); //offset 
                        childObject2.transform.rotation = Instance.transform.rotation;
                        childObject2.transform.localScale = new Vector3(1f, 1f);
                        var childSprite2 = childObject2.AddComponent<SpriteRenderer>();
                        childSprite2.sprite = ModAPI.LoadSprite("Taran Tactical/JW3 Combat Master Bolt 2.png", 23f);
                        childSprite2.sortingLayerName = "Background";                     
                        childSprite2.sortingOrder = -1;

                        
                        ;Instance.FixColliders();
						Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.185f, 0.105f);
                        Instance.GetComponent<FirearmBehaviour>().InitialInaccuracy = 0.0115f;
						firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/M1911.mp3"),

                        };
                    }
                }
            );
// ignore this bomb code, is for mark the code end
						            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("General Purpose Bomb"),
                    NameOverride = tarantactical + "[United States Army] Mk-82 500 LB General Purpose Bomb",
                    NameToOrderByOverride = "Napalm",
                    DescriptionOverride = "Use to commit war crimes",
                    CategoryOverride = ModAPI.FindCategory("Penesote"),
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/MISC/3.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Another Things/Mk-82 500 LB General Purpose Bomb.png", 5f);
						Instance.FixColliders();
                        Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 1f;
                    }
                }
            );

              }   

public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
        public Texture2D[] Textures = new Texture2D[0];
        public PersonBehaviour person;
        public int CurrentTexture = -2;
        public int Scale = 6;

        void Start()
        {
            SetTexture();
        }

        public void SetTexture()
        {
            if (Textures.Length == 0)
                return;

            if(CurrentTexture == -2)
            {
                CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
            }
            person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
            for (int i = 0; i < person.Limbs.Length; i++)
            {
                person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
            }
        }
}    }
}			